=== modified file 'baz2bzr'
--- baz2bzr	2005-05-15 22:31:18 +0000
+++ baz2bzr	2005-05-20 22:50:42 +0000
@@ -183,6 +183,7 @@
     Import complete.
     >>> teardown_environ(q)
     """
+    progress_bar = ProgressBar()
     tempdir = tempfile.mkdtemp(prefix="baz2bzr")
     try:
         if not fancy:

=== modified file 'progress.py'
--- progress.py	2005-05-10 19:14:23 +0000
+++ progress.py	2005-05-20 22:50:42 +0000
@@ -16,6 +16,7 @@
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import sys
+import datetime
 
 class Progress(object):
     def __init__(self, units, current, total=None):
@@ -33,16 +34,59 @@
         else:
             return "%i %s" (self.current, self.units) 
 
-
-def progress_bar(progress):
+class ProgressBar(object):
+    def __init__(self):
+        self.start = None
+        object.__init__(self)
+
+    def __call__(self, progress):
+        if self.start is None:
+            self.start = datetime.datetime.now()
+        progress_bar(progress, start_time=self.start)
+        
+def divide_timedelta(delt, divisor):
+    """Divides a timedelta object"""
+    return datetime.timedelta(float(delt.days)/divisor, 
+                              float(delt.seconds)/divisor, 
+                              float(delt.microseconds)/divisor)
+
+def str_tdelta(delt):
+    if delt is None:
+        return "-:--:--"
+    return str(datetime.timedelta(delt.days, delt.seconds))
+
+def get_eta(start_time, progress, enough_samples=20):
+    if start_time is None or progress.current == 0:
+        return None
+    elif progress.current < enough_samples:
+        return None
+    elapsed = datetime.datetime.now() - start_time
+    total_duration = divide_timedelta((elapsed) * long(progress.total), 
+                                      progress.current)
+    if elapsed < total_duration:
+        eta = total_duration - elapsed
+    else:
+        eta = total_duration - total_duration
+    return eta
+
+def progress_bar(progress, start_time=None):
+    eta = get_eta(start_time, progress)
+    if start_time is not None:
+        eta_str = " "+str_tdelta(eta)
+    else:
+        eta_str = ""
+
     fmt = " %i of %i %s (%.1f%%)"
     f = fmt % (progress.total, progress.total, progress.units, 100.0)
     max = len(f)
     cols = 77 - max
+    if start_time is not None:
+        cols -= len(eta_str)
     markers = int (float(cols) * progress.current / progress.total)
     txt = fmt % (progress.current, progress.total, progress.units,
                  progress.percent)
-    sys.stderr.write("\r[%s%s]%s" % ('='*markers, ' '*(cols-markers), txt))
+    sys.stderr.write("\r[%s%s]%s%s" % ('='*markers, ' '*(cols-markers), txt, 
+                                       eta_str))
 
 def clear_progress_bar():
     sys.stderr.write('\r%s\r' % (' '*79))

